/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-responses-status-menu.html
 */

/// <reference path="../polymer/types/polymer-element.d.ts" />
/// <reference path="../polymer/types/lib/elements/dom-repeat.d.ts" />
/// <reference path="../paper-item/paper-item.d.ts" />
/// <reference path="../paper-listbox/paper-listbox.d.ts" />

declare namespace ApiElements {

  /**
   * `api-responses-status-menu`
   *
   * An element that renders list of status codes as a list options.
   *
   * ## Styling
   *
   * `<api-responses-status-menu>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--api-responses-status-menu` | Mixin applied to this elment | `{}`
   * `--arc-status-code-color-200` | Color of the 200 status code (ARC theme option) | `rgba(56, 142, 60, 1)` |
   * `--arc-status-code-color-300` | Color of the 300 status code (ARC theme option) | `rgba(48, 63, 159, 1)` |
   * `--arc-status-code-color-400` | Color of the 400 status code (ARC theme option) | `rgba(245, 124, 0, 1)` |
   * `--arc-status-code-color-500` | Color of the 500 status code (ARC theme option) | `rgba(211, 47, 47, 1)` |
   * `--arc-status-code-bgcolor-200` | Background color of the 200 status code | `rgba(56, 142, 60, 0.12)` |
   * `--arc-status-code-bgcolor-300` | Background color of the 300 status code | `rgba(48, 63, 159, 0.12)` |
   * `--arc-status-code-bgcolor-400` | Background color of the 400 status code | `rgba(245, 124, 0, 0.12)` |
   * `--arc-status-code-bgcolor-500` | Background color of the 500 status code | `rgba(211, 47, 47, 0.12)` |
   */
  class ApiResponsesStatusMenu extends Polymer.Element {

    /**
     * List of status codes to render.
     *
     * Example:
     * ```javascript
     * [200, 204, 400, 401, 404]
     * ```
     */
    codes: Array<String|Number|null>|null;

    /**
     * Currently selected index in `codes` array.
     * Note that this value is re-set to `0` when codes changes.
     */
    selected: number|null|undefined;

    /**
     * Sets `selected` 0 when codes changes.
     * It only sets selection if there's actually a value to render.
     * It prohibits from performing additional computations for nothing.
     */
    _codesChanged(codes: any[]|null): void;

    /**
     * Computes class name for the code display depending on range.
     *
     * @param code Status code
     * @returns Color associated with the code.
     */
    _computeCodeClass(code: String|Number|null): String|null;
  }
}

interface HTMLElementTagNameMap {
  "api-responses-status-menu": ApiElements.ApiResponsesStatusMenu;
}
